function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { DrawingManager } from 'react-google-maps/lib/components/drawing/DrawingManager';
import { MAP } from 'react-google-maps/lib/constants';

import { GeoJsonEditorMode } from '../../utils';

var Drawer = function (_Component) {
    _inherits(Drawer, _Component);

    function Drawer(props, context) {
        _classCallCheck(this, Drawer);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        console.log('[GeoJsonViewer] path', _this.context[MAP]);
        // const newData = new google.maps.Data();
        // newData.addGeoJson(props.geojsonData);
        // newData.setMap(this.context[MAP]);
        return _this;
    }

    Drawer.prototype.componentDidMount = function componentDidMount() {};

    Drawer.prototype.componentWillUnmount = function componentWillUnmount() {};

    Drawer.prototype.render = function render() {
        var defaultOptions = {
            drawingControl: false,
            drawingControlOptions: {
                position: google.maps.ControlPosition.TOP_CENTER,
                drawingModes: [google.maps.drawing.OverlayType.POLYGON]
            },
            polygonOptions: {
                fillColor: '#455A64',
                fillOpacity: 0.3,
                strokeColor: '#455A64',
                strokeWeight: 3,
                clickable: true,
                editable: true, // @TODO
                zIndex: 1
            }
        };
        var props = this.props;
        return React.createElement(DrawingManager, {
            defaultDrawingMode: props.mode === GeoJsonEditorMode.CREATE ? google.maps.drawing.OverlayType.POLYGON : null,
            defaultOptions: defaultOptions,
            onPolygonComplete: function onPolygonComplete(polygon) {
                polygon.setEditable(false);
                props.onCreatePolygon(polygon);

                // START @TODO find another way to achieve this

                var _polygon$getPaths$get = polygon.getPaths().getArray(),
                    path = _polygon$getPaths$get[0];

                google.maps.event.addListener(polygon, 'click', function () {
                    props.onClickPolygon(polygon);
                });
                google.maps.event.addListener(path, 'insert_at', function (i) {
                    console.log('[addListener] path insert_at', i, path);
                    props.onUpdatePolygon(polygon);
                });
                google.maps.event.addListener(path, 'remove_at', function (i) {
                    // Point was removed
                    console.log('[addListener] path remove_at', i);
                    props.onUpdatePolygon(polygon);
                });

                google.maps.event.addListener(path, 'set_at', function (i) {
                    // Point was moved
                    console.log('[addListener] path set_at', i);
                    props.onUpdatePolygon(polygon);
                });
                // END @TODO find another way to achieve this
            },
            ref: props.getDMRef
        });
    };

    return Drawer;
}(Component);

export { Drawer as default };