import React from 'react';
import { withScriptjs, withGoogleMap, GoogleMap } from
// Polygon,
'react-google-maps';
import { GeoJsonEditorMode } from '../../utils';
import Drawer from './Drawer';
import Viewer from './Viewer';

var GMap = withScriptjs(withGoogleMap(function (props) {
    return React.createElement(
        GoogleMap,
        {
            defaultZoom: 10,
            defaultCenter: { lat: 51.528308, lng: -0.3817765 }
        },
        React.createElement(Drawer, {
            key: 'DRAWER-' + props.updator // @NOTE we do this because "react-google-maps" does not update the defaultDrawingMode
            , mode: props.mode,
            getDMRef: props.getDMRef,

            onCreatePolygon: props.onCreatePolygon,
            onClickPolygon: props.onClickPolygon,
            onUpdatePolygon: props.onUpdatePolygon
        }),
        React.createElement(Viewer, {
            key: 'VIEWER-' + props.updator,
            geojsonData: props.existingPolygons,
            allowEditing: props.mode === GeoJsonEditorMode.EDIT,
            onDrawExistingPolygons: props.onDrawExistingPolygons,
            onUpdatePolygon: props.onUpdatePolygon,
            onClickPolygon: props.onClickPolygon
        })
    );
}));

export default GMap;