function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { GeoJsonEditorMode } from '../../utils';

export var CRadio = function CRadio(_ref) {
    var group = _ref.group,
        id = _ref.id,
        value = _ref.value,
        label = _ref.label,
        checked = _ref.checked,
        onChange = _ref.onChange;
    return React.createElement(
        'label',
        { htmlFor: id },
        React.createElement('input', {
            type: 'radio', name: group, id: id,
            value: value,
            checked: checked, onChange: onChange
        }),
        React.createElement(
            'span',
            null,
            label
        )
    );
};

var RadioGroup = function (_Component) {
    _inherits(RadioGroup, _Component);

    function RadioGroup(props) {
        _classCallCheck(this, RadioGroup);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.instanceId = Math.random().toFixed(5).replace('0.', '');
        _this.state = {
            selectedOption: props.defaultMode,
            modeList: [{ label: 'VIEW mode', value: GeoJsonEditorMode.VIEW, checked: true }, { label: 'CREATE mode', value: 'CREATE', checked: false }, { label: 'EDIT mode', value: 'EDIT', checked: false }, { label: 'DELETE mode', value: 'DELETE', checked: false }]
        };
        return _this;
    }

    RadioGroup.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
        var resetTrigger = this.props.resetTrigger;
        var selectedOption = this.state.selectedOption;


        return nextProps.resetTrigger !== resetTrigger || nextState.selectedOption !== selectedOption;
    };

    RadioGroup.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
        // @NOTE assumption is that update for initialMode cannot happen at the same time as update for existingPolygons 
        var _props = this.props,
            resetTrigger = _props.resetTrigger,
            defaultMode = _props.defaultMode;

        if (prevProps.resetTrigger !== resetTrigger) {
            this.setState({ selectedOption: defaultMode });
        }
    };

    RadioGroup.prototype.render = function render() {
        var _this2 = this;

        var _onChange = this.props.onChange;
        var _state = this.state,
            modeList = _state.modeList,
            selectedOption = _state.selectedOption;

        return React.createElement(
            'div',
            { style: { display: 'flex', flexDirection: 'row' } },
            modeList.map(function (mode, i) {
                return React.createElement(
                    'div',
                    { style: { marginRight: 10 }, key: _this2.uniqueId + '-' + i },
                    React.createElement('input', {
                        type: 'radio', id: 'mode-' + _this2.instanceId + '-' + i, name: 'mode-' + _this2.instanceId,
                        onChange: function onChange(ev) {
                            _this2.setState({ selectedOption: mode.value }, function () {
                                _onChange(mode.value);
                            });
                        }, value: mode.value, checked: selectedOption === mode.value
                    }),
                    React.createElement(
                        'label',
                        { style: { margin: 5 }, htmlFor: 'mode-' + _this2.instanceId + '-' + i },
                        mode.label
                    )
                );
            })
        );
    };

    return RadioGroup;
}(Component);

export default RadioGroup;