'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactGoogleMaps = require('react-google-maps');

var _utils = require('../../utils');

var _Drawer = require('./Drawer');

var _Drawer2 = _interopRequireDefault(_Drawer);

var _Viewer = require('./Viewer');

var _Viewer2 = _interopRequireDefault(_Viewer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GMap = (0, _reactGoogleMaps.withScriptjs)((0, _reactGoogleMaps.withGoogleMap)(function (props) {
    return _react2.default.createElement(
        _reactGoogleMaps.GoogleMap,
        {
            defaultZoom: 10,
            defaultCenter: { lat: 51.528308, lng: -0.3817765 }
        },
        _react2.default.createElement(_Drawer2.default, {
            key: 'DRAWER-' + props.updator // @NOTE we do this because "react-google-maps" does not update the defaultDrawingMode
            , mode: props.mode,
            getDMRef: props.getDMRef,

            onCreatePolygon: props.onCreatePolygon,
            onClickPolygon: props.onClickPolygon,
            onUpdatePolygon: props.onUpdatePolygon
        }),
        _react2.default.createElement(_Viewer2.default, {
            key: 'VIEWER-' + props.updator,
            geojsonData: props.existingPolygons,
            allowEditing: props.mode === _utils.GeoJsonEditorMode.EDIT,
            onDrawExistingPolygons: props.onDrawExistingPolygons,
            onUpdatePolygon: props.onUpdatePolygon,
            onClickPolygon: props.onClickPolygon
        })
    );
}));

exports.default = GMap;
module.exports = exports['default'];