'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactGoogleMaps = require('react-google-maps');

var _constants = require('react-google-maps/lib/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Viewer = function (_Component) {
    _inherits(Viewer, _Component);

    function Viewer(props, context) {
        _classCallCheck(this, Viewer);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        _this.polygonRefs = [];
        console.log('[GeoJsonViewer] path', _this.context[_constants.MAP]);

        // const newData = new google.maps.Data();
        // newData.addGeoJson(props.geojsonData);
        // newData.setMap(this.context[MAP]);

        return _this;
    }

    Viewer.prototype.shouldComponentUpdate = function shouldComponentUpdate() /* , */{
        return false;
    };

    Viewer.prototype.componentDidMount = function componentDidMount() {
        var _props = this.props,
            onUpdatePolygon = _props.onUpdatePolygon,
            onClickPolygon = _props.onClickPolygon,
            onDrawExistingPolygons = _props.onDrawExistingPolygons;


        var polygons = this.polygonRefs.map(function (el) {
            // const polygons = [].map((el) => {
            var polygon = el.state[_constants.POLYGON];

            var _polygon$getPaths$get = polygon.getPaths().getArray(),
                path = _polygon$getPaths$get[0];

            console.log('[ExistingPolygonList.componentDidMount] path', path.getArray());
            return polygon;
        });
        polygons.forEach(function (polygon) {
            var _polygon$getPaths$get2 = polygon.getPaths().getArray(),
                path = _polygon$getPaths$get2[0];

            google.maps.event.addListener(polygon, 'click', function (i) {
                onClickPolygon(polygon);
            });

            // props.onCreatePolygon(polygon);
            google.maps.event.addListener(path, 'insert_at', function (i) {
                console.log('[addListener] path insert_at', i, path);
                onUpdatePolygon(polygon);
            });
            google.maps.event.addListener(path, 'remove_at', function (i) {
                // Point was removed
                console.log('[addListener] path remove_at', i);
                onUpdatePolygon(polygon);
            });

            google.maps.event.addListener(path, 'set_at', function (i) {
                // Point was moved
                console.log('[addListener] path set_at', i);
                onUpdatePolygon(polygon);
            });
        });

        // Main reason why this GeoJsonManager exists 
        onDrawExistingPolygons(polygons);
        console.log('[google.maps.event.addListener.removeListener] path', google.maps.event.addListener.removeListener);
    };

    Viewer.prototype.componentWillUnmount = function componentWillUnmount() {
        // polygons.forEach((polygon) => {
        //     const [path] = polygon.getPaths().getArray();
        //     google.maps.event.addListener.removeListener(path, 'insert_at');
        //     google.maps.event.addListener.removeListener(path, 'remove_at');
        //     google.maps.event.addListener.removeListener(path, 'set_at');
        // });
    };

    Viewer.prototype.render = function render() {
        var _this2 = this;

        var newData = new google.maps.Data();
        newData.addGeoJson(this.props.geojsonData);

        var pList = [];
        newData.forEach(function (feature) {
            var multiPolygon = feature.getGeometry();
            var pathList = multiPolygon.getArray().map(function (polygon) {
                var _polygon$getArray = polygon.getArray(),
                    firstPath = _polygon$getArray[0]; // polygon can have multiple paths


                return firstPath;
            });

            pList = [].concat(pList, pathList);
        });
        // newData.setMap(this.context[MAP]);

        return _react2.default.createElement(
            'div',
            null,
            pList.map(function (p, i) {
                return _react2.default.createElement(_reactGoogleMaps.Polygon, {
                    key: i.toString(),
                    ref: function ref(el) {
                        // console.log('[getGeometry] render', Math.random());
                        if (!el) return;
                        _this2.polygonRefs.push(el);
                    },
                    editable: _this2.props.allowEditing,
                    clickable: true,
                    paths: p.getArray()
                });
            })
        );
    };

    return Viewer;
}(_react.Component);

exports.default = Viewer;
module.exports = exports['default'];