'use strict';

exports.__esModule = true;

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('react-google-maps/lib/constants');

var _GMap = require('./GMap');

var _GMap2 = _interopRequireDefault(_GMap);

var _utils = require('../../utils');

var _index = require('../URadioGroup/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import RadioGroup from './RadioGroup';


var GeoJsonEditor = function (_Component) {
    _inherits(GeoJsonEditor, _Component);

    function GeoJsonEditor(props) {
        _classCallCheck(this, GeoJsonEditor);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.onDrawExistingPolygons = function (polygons) {
            // const { onCreate, onUpdate } = this.props;
            _this.setState(function (state) {
                return { polygons: [].concat(state.polygons, polygons) };
            });
        };

        _this.onSetPolygons = function (polygons) {
            _this.setState({ polygons: polygons });
        };

        _this.onCreatePolygon = function (polygon) {
            _this.setState(function (state) {
                var polygons = [].concat(state.polygons, [polygon]);
                return { polygons: polygons };
            });
            // @TODO usecase: Allow user to take action when a new polygon is created
            // this.setState(() => {
            //     const polygons = [...this.state.polygons, polygon];
            //     return { polygons } }, this.props.onCreate ? () => {
            //     createGeoJson(google, this.state.polygons, this.props.onCreate)
            // } : null); 
        };

        _this.onUpdatePolygon = function (polygon) {
            // onUpdate(createMPGeojson(this.state.polygons))
            console.log('[onUpdatePolygon] polygon', polygon);
        };

        _this.onClickPolygon = function (polygon) {
            console.log('[polygon] polygon', _this.state.polygons);
            if (_this.state.editorMode === _utils.GeoJsonEditorMode.DELETE) {
                _this.setState(function (state) {
                    polygon.setMap(null);
                    polygon.setMap(null);
                    var polygons = state.polygons.filter(function (p) {
                        return p !== polygon;
                    });
                    return { polygons: polygons };
                });
            }
        };

        _this.state = {
            polygons: [],
            editorMode: props.initialMode,
            existingPolygons: props.existingPolygons,
            resetTrigger: 0
        };
        _this.DM = null;
        _this.MAP = null;
        return _this;
    }

    GeoJsonEditor.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
        var existingPolygons = this.props.existingPolygons;
        var _state = this.state,
            resetTrigger = _state.resetTrigger,
            editorMode = _state.editorMode;


        return nextProps.existingPolygons !== existingPolygons || nextState.resetTrigger !== resetTrigger || nextState.editorMode !== editorMode;
    };

    GeoJsonEditor.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
        var _this2 = this;

        var existingPolygons = this.props.existingPolygons;

        if (prevProps.existingPolygons !== existingPolygons) {
            this.setState(function (state) {
                state.polygons.forEach(function (p) {
                    p.setMap(null);
                });
                return { editorMode: _this2.props.initialMode, existingPolygons: existingPolygons, resetTrigger: Math.random() };
            });
        }
    };

    GeoJsonEditor.prototype.render = function render() {
        var _this3 = this;

        var _state2 = this.state,
            resetTrigger = _state2.resetTrigger,
            editorMode = _state2.editorMode,
            existingPolygons = _state2.existingPolygons;


        return _react2.default.createElement(
            'div',
            { style: { width: '100%', height: 400, minHeight: 300 } },
            _react2.default.createElement(_index.URadioGroup, {
                resetTrigger: resetTrigger,
                selectedOption: editorMode,
                handleChange: function handleChange(mode) {
                    switch (mode) {
                        case _utils.GeoJsonEditorMode.VIEW:
                        case _utils.GeoJsonEditorMode.DELETE:
                            _this3.DM.setDrawingMode(null);
                            _this3.state.polygons.forEach(function (p) {
                                p.setEditable(false);
                            });
                            break;
                        case _utils.GeoJsonEditorMode.CREATE:
                            _this3.DM.setDrawingMode(google.maps.drawing.OverlayType.POLYGON);
                            _this3.state.polygons.forEach(function (p) {
                                p.setEditable(false);
                            });
                            break;
                        case _utils.GeoJsonEditorMode.EDIT:
                            _this3.DM.setDrawingMode(null);
                            _this3.state.polygons.forEach(function (p) {
                                p.setEditable(true);
                            });
                            break;
                    }
                    _this3.setState({ editorMode: mode });
                }
            }),
            _react2.default.createElement(_GMap2.default, {
                googleMapURL: 'https://maps.googleapis.com/maps/api/js?key=AIzaSyD_HADQAEoHkZhBhqh-oDaiLHuRyHbyP9c&v=3.exp&libraries=geometry,drawing,places',
                loadingElement: _react2.default.createElement('div', { style: { height: '100%' } }),
                containerElement: _react2.default.createElement('div', { style: { height: '100%', width: '100%' } }),
                mapElement: _react2.default.createElement('div', { style: { height: '100%' } }),

                existingPolygons: existingPolygons,
                onDrawExistingPolygons: this.onSetPolygons.bind(this),
                onCreatePolygon: this.onCreatePolygon.bind(this),
                onUpdatePolygon: this.onUpdatePolygon.bind(this),
                onClickPolygon: this.onClickPolygon.bind(this),
                getDMRef: function getDMRef(el) {
                    if (!el) return;
                    _this3.MAP = el.context[_constants.MAP];
                    _this3.DM = el.state[_constants.DRAWING_MANAGER];
                    console.log('[el - el - el - el - el]', Math.random(), _this3.DM, _this3.MAP);
                },
                mode: editorMode,
                updator: resetTrigger
            }),
            _react2.default.createElement(
                'div',
                { style: { display: 'flex', flexDirection: 'column', padding: 10, textAlign: 'center' }, className: 'jsx-2365529220'
                },
                _react2.default.createElement(
                    'div',
                    { style: { display: 'flex', flexDirection: 'row', padding: 10 }, className: 'jsx-2365529220'
                    },
                    _react2.default.createElement(
                        'button',
                        { onClick: function onClick() {
                                return (0, _utils.createGeoJson)(google, _this3.state.polygons, _this3.props.onSave);
                            }, className: 'jsx-2365529220' + ' ' + 'primary'
                        },
                        existingPolygons ? 'UPDATE' : 'SAVE'
                    ),
                    ' \xA0',
                    _react2.default.createElement(
                        'button',
                        { onClick: function onClick() {
                                // @TODO
                                _this3.state.polygons.forEach(function (p) {
                                    p.setMap(null);
                                });
                                _this3.setState({ editorMode: _this3.props.initialMode, resetTrigger: Math.random() });
                            }, className: 'jsx-2365529220'
                        },
                        'RESET'
                    )
                ),
                _react2.default.createElement(
                    _style2.default,
                    {
                        id: '2365529220'
                    },
                    'button.jsx-2365529220{border:1px solid #0074FF;font-family:Graphik-Medium;font-size:12px;color:#0074FF;-webkit-letter-spacing:2px;-moz-letter-spacing:2px;-ms-letter-spacing:2px;letter-spacing:2px;text-align:center;height:40px;border-radius:10px;margin-right:5px;cursor:pointer;}button.primary.jsx-2365529220{background:#0074FF;color:#FFFFFF;}'
                )
            )
        );
    };

    return GeoJsonEditor;
}(_react.Component);

exports.default = GeoJsonEditor;


GeoJsonEditor.propTypes = process.env.NODE_ENV !== "production" ? {
    initialMode: _propTypes2.default.string,
    existingPolygons: _propTypes2.default.object,
    onSave: _propTypes2.default.func,
    onCreate: _propTypes2.default.func,
    onUpdate: _propTypes2.default.func
} : {};
GeoJsonEditor.defaultProps = {
    initialMode: _utils.GeoJsonEditorMode.VIEW,
    onSave: function onSave() {}
};
module.exports = exports['default'];