'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactGoogleMaps = require('react-google-maps');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MapWithAMarker = (0, _reactGoogleMaps.withScriptjs)((0, _reactGoogleMaps.withGoogleMap)(function (props) {
    var geojson = props.geojson;

    var polygonData = geojson.coordinates;

    var polygonList = polygonData.map(function (polygon) {

        var pathList = polygon.map(function (polygonCorners) {
            var points = polygonCorners.map(function (p) {
                return new (Function.prototype.bind.apply(google.maps.LatLng, [null].concat(p)))();
            });
            return points;
        });

        var first = pathList[0],
            last = pathList[1];

        var outerBox = google.maps.geometry.spherical.computeArea(first);
        var innerBox = last ? google.maps.geometry.spherical.computeArea(last) : 0;
        var area = innerBox ? outerBox - innerBox : outerBox;
        console.log(pathList, area);
        return { pathList: pathList, area: area };
    });

    return _react2.default.createElement(
        _reactGoogleMaps.GoogleMap,
        {
            defaultZoom: 10,
            defaultCenter: { lat: 51.528308, lng: -0.3817765 },
            onClick: function onClick(e) {
                console.log('eeeeee onClick eeeeeeee', e.latLng.lat(), e.latLng.lng());
                // const marker = new google.maps.Marker(markerProps);
            }
        },
        _react2.default.createElement(_reactGoogleMaps.Marker, { position: { lat: 51.528308, lng: -0.3817765 }, draggable: true }),
        polygonList.map(function (polygon, i) {
            return _react2.default.createElement(
                'div',
                { key: i.toString() },
                polygon.pathList.map(function (path, i) {
                    return _react2.default.createElement(_reactGoogleMaps.Polygon, { paths: path, key: i.toString() });
                })
            );
        })
    );
}));

var MapSelectionViewer = function (_Component) {
    _inherits(MapSelectionViewer, _Component);

    function MapSelectionViewer() {
        _classCallCheck(this, MapSelectionViewer);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    MapSelectionViewer.prototype.render = function render() {

        return _react2.default.createElement(
            'div',
            { style: { width: 800, height: '95%', minHeight: 400 } },
            _react2.default.createElement(MapWithAMarker, {
                googleMapURL: 'https://maps.googleapis.com/maps/api/js?key=AIzaSyD_HADQAEoHkZhBhqh-oDaiLHuRyHbyP9c&v=3.exp&libraries=geometry,drawing,places',
                loadingElement: _react2.default.createElement('div', { style: { height: '100%' } }),
                containerElement: _react2.default.createElement('div', { style: { height: '100%', width: '100%' } }),
                mapElement: _react2.default.createElement('div', { style: { height: '100%' } }),
                geojson: this.props.geojson
            })
        );
    };

    return MapSelectionViewer;
}(_react.Component);

exports.default = MapSelectionViewer;
module.exports = exports['default'];