'use strict';

exports.__esModule = true;
exports.GeoJsonManager = exports.createMPGeojson = exports.createMPGeojson1 = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('react-google-maps/lib/constants');

var _reactGoogleMaps = require('react-google-maps');

var _DrawingManager = require('react-google-maps/lib/components/drawing/DrawingManager');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MapWithAMarker = (0, _reactGoogleMaps.withScriptjs)((0, _reactGoogleMaps.withGoogleMap)(function (props) {
    return _react2.default.createElement(
        _reactGoogleMaps.GoogleMap,
        {
            defaultZoom: 10,
            defaultCenter: { lat: 51.528308, lng: -0.3817765 },
            onClick: function onClick(e) {
                console.log('eeeeee onClick eeeeeeee', e.latLng.lat(), e.latLng.lng());
            },
            onDragEnd: function onDragEnd(e) {
                console.log('eeeeee onDragEnd eeeeeeee', e);
            }
        },
        _react2.default.createElement(_DrawingManager.DrawingManager, {
            defaultDrawingMode: google.maps.drawing.OverlayType.POLYGON,
            defaultOptions: {
                drawingControl: true, // false for view Mode
                drawingControlOptions: {
                    position: google.maps.ControlPosition.TOP_CENTER,
                    drawingModes: [google.maps.drawing.OverlayType.POLYGON]
                },
                polygonOptions: {
                    fillColor: '#455A64',
                    fillOpacity: 0.3,
                    strokeColor: '#455A64',
                    strokeWeight: 3,
                    clickable: true,
                    editable: true,
                    zIndex: 1
                }
            },
            onPolygonComplete: function onPolygonComplete(polygon) {
                var _polygon$getPaths$get = polygon.getPaths().getArray(),
                    path = _polygon$getPaths$get[0]; //.getArray()[0].getArray().map(o=>o.toJSON()));

                // console.log('[onPolygonComplete] polygon', Object.keys(google.maps.Data));

                // @TODO find another way to achieve this


                props.onCreatePolygon(polygon);
                google.maps.event.addListener(path, 'insert_at', function (i) {
                    console.log('[addListener] path insert_at', i, path);
                    props.onUpdatePolygon(polygon);
                });
                google.maps.event.addListener(path, 'remove_at', function (i) {
                    // Point was removed
                    console.log('[addListener] path remove_at', i);
                    props.onUpdatePolygon(polygon);
                });

                google.maps.event.addListener(path, 'set_at', function (i) {
                    // Point was moved
                    console.log('[addListener] path set_at', i);
                    props.onUpdatePolygon(polygon);
                });
            }
        }),
        _react2.default.createElement(GeoJsonManager, {
            geojsonData: props.existingPolygons,
            onDrawExistingPolygons: props.onDrawExistingPolygons,
            onUpdatePolygon: props.onUpdatePolygon
        })
    );
}));

var MapSelector = function (_Component) {
    _inherits(MapSelector, _Component);

    function MapSelector() {
        var _temp, _this, _ret;

        _classCallCheck(this, MapSelector);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
            polygons: []
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    MapSelector.prototype.shouldComponentUpdate = function shouldComponentUpdate() {
        return false;
    };

    MapSelector.prototype.render = function render() {
        var _this2 = this;

        var _props = this.props,
            onCreate = _props.onCreate,
            onUpdate = _props.onUpdate,
            mode = _props.mode;
        // enum<{ CREATE, EDIT, VIEW }>

        var GeoJsonManagerMode = { CREATE: 'CREATE', EDIT: 'EDIT', VIEW: 'VIEW' };

        return _react2.default.createElement(
            'div',
            { style: { width: 800, height: '95%', minHeight: 400 } },
            _react2.default.createElement(MapWithAMarker, {
                googleMapURL: 'https://maps.googleapis.com/maps/api/js?key=AIzaSyD_HADQAEoHkZhBhqh-oDaiLHuRyHbyP9c&v=3.exp&libraries=geometry,drawing,places',
                loadingElement: _react2.default.createElement('div', { style: { height: '100%' } }),
                containerElement: _react2.default.createElement('div', { style: { height: '100%', width: '100%' } }),
                mapElement: _react2.default.createElement('div', { style: { height: '100%' } }),
                onDrawExistingPolygons: function onDrawExistingPolygons(polygons) {
                    _this2.setState(function () {
                        console.log('[polygon] polygon', _this2.state.polygons);
                        return { polygons: [].concat(_this2.state.polygons, polygons) };
                    });
                },

                onCreatePolygon: function onCreatePolygon(polygon) {
                    _this2.setState(function () {
                        console.log('[polygon] polygon', _this2.state.polygons);
                        var polygons = [].concat(_this2.state.polygons, [polygon]);
                        return { polygons: polygons };
                    }, function () {
                        // onCreate(createMPGeojson(polygons)); // @TODO maybe use setState callback?
                        createMPGeojson1(_this2.state.polygons);
                    });
                },
                onUpdatePolygon: function onUpdatePolygon() /* polygon */{
                    // onUpdate(createMPGeojson(this.state.polygons))
                    console.log('[polygon] polygon', _this2.state.polygons);
                    createMPGeojson1(_this2.state.polygons);
                }
            })
        );
    };

    return MapSelector;
}(_react.Component);

exports.default = MapSelector;
var createMPGeojson1 = exports.createMPGeojson1 = function createMPGeojson1(polygons) {

    var newData = new google.maps.Data();
    newData.add(new google.maps.Data.Feature({
        geometry: new google.maps.Data.MultiPolygon(polygons.map(function (polygon) {
            return polygon.getPaths().getArray().map(function (path) {
                return path.getArray();
            });
        }))
    }));

    newData.toGeoJson(function (geoJSON) {
        console.log('[createMPGeojson1] geoJSON', geoJSON);
    });
};

/**
 * #https://developers.google.com/maps/documentation/javascript/reference/polygon
 * @param {Array<Polygon>} polygons 
 * @returns MultiPolygon GeoJSON #http://geojson.org/
 */
var createMPGeojson = exports.createMPGeojson = function createMPGeojson(polygons) {

    // START create geojson paths and area for each polygon
    // cleanedPolygons: Array<{ polygon: Array<Array<[ longitude: number, latitude: number]>>, area: number }>
    var cleanedPolygons = polygons.map(function (p) {
        var _p$getPaths$getArray = p.getPaths().getArray(),
            path = _p$getPaths$getArray[0]; // @TODO edit this for hollow polygons


        return {
            pathList: [path.getArray().map(function (c) {
                return [c.lng(), c.lat()];
            })],
            area: google.maps.geometry.spherical.computeArea(path.getArray())
        };
    });
    // START create geometry and area for each polygon

    var geometry = {
        type: 'MultiPolygon',
        coordinates: cleanedPolygons.map(function (cp) {
            return cp.pathList;
        })
    };
    var totalArea = cleanedPolygons.reduce(function (ac, cp) {
        return ac + cp.area;
    }, 0);

    return {
        type: 'Feature',
        geometry: geometry,
        properties: { totalArea: totalArea }
    };
};

var GeoJsonManager = exports.GeoJsonManager = function (_Component2) {
    _inherits(GeoJsonManager, _Component2);

    function GeoJsonManager(props) {
        _classCallCheck(this, GeoJsonManager);

        var _this3 = _possibleConstructorReturn(this, _Component2.call(this, props));

        _this3.polygonRefs = [];
        return _this3;
    }

    GeoJsonManager.prototype.shouldComponentUpdate = function shouldComponentUpdate() {
        return false;
    };

    GeoJsonManager.prototype.componentDidMount = function componentDidMount() {
        var _props2 = this.props,
            onUpdatePolygon = _props2.onUpdatePolygon,
            onDrawExistingPolygons = _props2.onDrawExistingPolygons;

        var polygons = this.polygonRefs.map(function (el) {
            var polygon = el.state[_constants.POLYGON];

            var _polygon$getPaths$get2 = polygon.getPaths().getArray(),
                path = _polygon$getPaths$get2[0];

            console.log('[ExistingPolygonList.componentDidMount] path', path.getArray());
            return polygon;
        });
        polygons.forEach(function (polygon) {
            var _polygon$getPaths$get3 = polygon.getPaths().getArray(),
                path = _polygon$getPaths$get3[0];
            // google.maps.event.addListener(polygon, 'click',  i => {
            // debugger
            // polygon.setEditable(true)
            // })

            // props.onCreatePolygon(polygon);


            google.maps.event.addListener(path, 'insert_at', function (i) {
                console.log('[addListener] path insert_at', i, path);
                onUpdatePolygon(polygon);
            });
            google.maps.event.addListener(path, 'remove_at', function (i) {
                // Point was removed
                console.log('[addListener] path remove_at', i);
                onUpdatePolygon(polygon);
            });

            google.maps.event.addListener(path, 'set_at', function (i) {
                // Point was moved
                console.log('[addListener] path set_at', i);
                onUpdatePolygon(polygon);
            });
        });

        // Main reason why this GeoJsonManager exists 
        onDrawExistingPolygons(polygons);
        console.log('[google.maps.event.addListener.removeListener] path', google.maps.event.addListener.removeListener);
    };

    GeoJsonManager.prototype.componentWillUnmount = function componentWillUnmount() {
        // polygons.forEach((polygon) => {
        //     const [path] = polygon.getPaths().getArray();
        //     google.maps.event.addListener.removeListener(path, 'insert_at');
        //     google.maps.event.addListener.removeListener(path, 'remove_at');
        //     google.maps.event.addListener.removeListener(path, 'set_at');
        // });
    };

    GeoJsonManager.prototype.render = function render() {
        var _this4 = this;

        var newData = new google.maps.Data();
        newData.addGeoJson(this.props.geojsonData);

        var pList = [];
        newData.forEach(function (feature) {
            var multiPolygon = feature.getGeometry();
            var pathList = multiPolygon.getArray().map(function (polygon) {
                var _polygon$getArray = polygon.getArray(),
                    firstPath = _polygon$getArray[0]; // polygon can have multiple paths


                return firstPath;
            });

            pList = [].concat(pList, pathList);
        });

        // this.props.polygonList 
        return pList.map(function (p, i) {
            return _react2.default.createElement(_reactGoogleMaps.Polygon, {
                key: i.toString(),
                ref: function ref(el) {
                    // console.log('[getGeometry] render', Math.random());
                    if (!el) return;
                    _this4.polygonRefs.push(el);
                },
                editable: false,
                clickable: true,
                onClick: function onClick(e) {
                    console.log('[]', e);
                    debugger;
                },
                paths: p.getArray()
            });
        });
    };

    return GeoJsonManager;
}(_react.Component);