'use strict';

exports.__esModule = true;
exports.Group = undefined;

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Radio = require('./Radio');

var _Radio2 = _interopRequireDefault(_Radio);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// controlled component
var Group = exports.Group = function (_Component) {
    _inherits(Group, _Component);

    function Group() {
        var _temp, _this, _ret;

        _classCallCheck(this, Group);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.uniqueId = 'radio-' + Math.random().toFixed(5).replace('0.', ''), _this.state = {
            radioList: [// CRUD
            { label: 'Create mode', value: _utils.GeoJsonEditorMode.CREATE }, { label: 'Read mode', value: _utils.GeoJsonEditorMode.VIEW }, { label: 'Update mode', value: _utils.GeoJsonEditorMode.EDIT }, { label: 'Delete mode', value: _utils.GeoJsonEditorMode.DELETE }]
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    Group.prototype.render = function render() {
        // console.log('[URadioGroup], render', this.props.initialSelection, this.state.initialSelection);
        // const uniqueId = `radio-${Math.random().toFixed(5).replace('0.', '')}`;
        var uniqueId = this.uniqueId;
        var _props = this.props,
            selectedOption = _props.selectedOption,
            handleChange = _props.handleChange;
        var radioList = this.state.radioList;


        return _react2.default.createElement(
            'div',
            {
                className: 'jsx-4228035141' + ' ' + 'radio-group'
            },
            radioList.map(function (_ref, i) {
                var value = _ref.value,
                    label = _ref.label;

                console.log('[radio] ' + uniqueId + '-' + i, value, label);
                return _react2.default.createElement(
                    'div',
                    { key: i.toString(), className: 'jsx-4228035141'
                    },
                    _react2.default.createElement(_Radio2.default, {
                        group: uniqueId, id: uniqueId + '-' + i, label: label,
                        value: value, checked: selectedOption === value,
                        onChange: function onChange(ev) {
                            return handleChange(ev.target.value);
                        }
                    })
                );
            }),
            _react2.default.createElement(
                _style2.default,
                {
                    id: '4228035141'
                },
                'div.radio-group.jsx-4228035141{width:auto;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;border:1px solid lightgray;border-bottom:none;}div.radio-group.jsx-4228035141>div.jsx-4228035141{margin:auto;margin-left:0;}'
            )
        );
    };

    return Group;
}(_react.Component);

exports.default = Group;