'use strict';

exports.__esModule = true;
var GeoJsonEditorMode = exports.GeoJsonEditorMode = { CREATE: 'CREATE', EDIT: 'EDIT', VIEW: 'VIEW', DELETE: 'DELETE' };

var createGeoJson = exports.createGeoJson = function createGeoJson(google, polygons, cb) {
    var newData = new google.maps.Data();
    newData.add(new google.maps.Data.Feature({
        geometry: new google.maps.Data.MultiPolygon(polygons.map(function (polygon) {
            return polygon.getPaths().getArray().map(function (path) {
                return path.getArray();
            });
        }))
    }));

    var area = polygons.reduce(function (acc, polygon) {
        var _polygon$getPaths$get = polygon.getPaths().getArray().map(function (path) {
            return path.getArray();
        }),
            first = _polygon$getPaths$get[0];

        var outerArea = google.maps.geometry.spherical.computeArea(first); // @TODO test correctness
        return acc + outerArea;
    }, 0);

    newData.toGeoJson(function (geoJSON) {
        // console.log('[createMPGeojson1] geoJSON', geoJSON);
        if (typeof cb === 'function') cb(geoJSON, area);
    });
};